package dev.fyloz.musicplayer.core.factory

import dev.fyloz.musicplayer.core.model.Track

class TrackFactoryProxy {
    private val factories = mutableMapOf<String, TrackFactory>()

    fun registerFactory(type: String, factory: TrackFactory) {
        factories[type] = factory;
    }

    suspend fun createTrack(type: String, id: String, trackId: String): Track {
        return getFactory(type).createTrack(id, trackId)
    }

    private fun getFactory(type: String) = factories[type]!!;
}
