package dev.fyloz.musicplayer.modules.spotify

import dev.fyloz.musicplayer.modules.spotify.api.Track
import io.ktor.client.*
import io.ktor.client.call.*
import io.ktor.client.plugins.contentnegotiation.*
import io.ktor.client.request.*
import io.ktor.http.*
import io.ktor.serialization.kotlinx.json.*
import kotlinx.serialization.json.Json

class SpotifyHttpProvider {
    private val client = HttpClient {
        install(ContentNegotiation) {
            json(Json {
                ignoreUnknownKeys = true
            })
        }
    }

    suspend fun getTrackById(trackId: String, token: String): Track {
        val tmpToken =
            "Bearer BQAtodg3W_kHLVJhGLFD0YEOh5AFfxSsrvhk1n9c0ELrlQdoEkbyOXYncN1k3umPfqqR3sesLI8qpJMxJ6-98nc4Z7KenedLBGyHfvBPzWg_U8OtwWy6jEWl7MbeFJYO50GNj-XRLPv6EAA1hPrrSIOhJBvOygs6hcDAYfD-_moA"

        val response = client.get("https://api.spotify.com/v1/tracks/$trackId") {
            accept(ContentType.Application.Json)
            headers {
                append(HttpHeaders.Authorization, tmpToken)
            }
        }

        return response.body()
    }
}
