package dev.fyloz.musicplayer.modules.spotify

import dev.fyloz.musicplayer.core.factory.TrackFactory
import dev.fyloz.musicplayer.core.model.Track

class SpotifyTrackFactory : TrackFactory {
    private val httpProvider = SpotifyHttpProvider()

    override suspend fun createTrack(id: String, trackId: String): Track {
        val spotifyApiTrack = httpProvider.getTrackById(trackId, "bla");

        return SpotifyTrack(id, trackId, spotifyApiTrack.name)
    }
}
